searchNodes=[{"doc":"Implements an Ueberauth.Strategy for AWS Cognito. Several options are available for configuring the strategy. The main keys you need to worry about are: auth_domain client_id client_secret user_pool_id aws_region These should all be available from your AWS Cognito setup. Additionally, there are a couple of options specifying what modules to use for some particular functions: http_client jwt_verifier These are mainly used for dependency injection when testing and users of this library shouldn't have to concern themselves with them.","ref":"Ueberauth.Strategy.Cognito.html","title":"Ueberauth.Strategy.Cognito","type":"module"},{"doc":"","ref":"Ueberauth.Strategy.Cognito.html#auth/1","title":"Ueberauth.Strategy.Cognito.auth/1","type":"function"},{"doc":"Returns standard Ueberauth.Auth.Credentials struct. The other key will be a map including a groups key, which is a list of any groups the user is associated with in Cognito","ref":"Ueberauth.Strategy.Cognito.html#credentials/1","title":"Ueberauth.Strategy.Cognito.credentials/1","type":"function"},{"doc":"","ref":"Ueberauth.Strategy.Cognito.html#default_options/0","title":"Ueberauth.Strategy.Cognito.default_options/0","type":"function"},{"doc":"The raw_info key of the returned struct includes everything from the raw Cognito response in cognito_id_token .","ref":"Ueberauth.Strategy.Cognito.html#extra/1","title":"Ueberauth.Strategy.Cognito.extra/1","type":"function"},{"doc":"Handle the callback step of the strategy.","ref":"Ueberauth.Strategy.Cognito.html#handle_callback!/1","title":"Ueberauth.Strategy.Cognito.handle_callback!/1","type":"function"},{"doc":"Handles the cleanup step of the strategy.","ref":"Ueberauth.Strategy.Cognito.html#handle_cleanup!/1","title":"Ueberauth.Strategy.Cognito.handle_cleanup!/1","type":"function"},{"doc":"Handle the request step of the strategy.","ref":"Ueberauth.Strategy.Cognito.html#handle_request!/1","title":"Ueberauth.Strategy.Cognito.handle_request!/1","type":"function"},{"doc":"Fetches the fields to populate the info section of the Ueberauth.Auth struct.","ref":"Ueberauth.Strategy.Cognito.html#info/1","title":"Ueberauth.Strategy.Cognito.info/1","type":"function"},{"doc":"Returns the username given in the Cognito response.","ref":"Ueberauth.Strategy.Cognito.html#uid/1","title":"Ueberauth.Strategy.Cognito.uid/1","type":"function"},{"doc":"Utilities for working with JSON Web Tokens","ref":"Ueberauth.Strategy.Cognito.JwtVerifier.html","title":"Ueberauth.Strategy.Cognito.JwtVerifier","type":"module"},{"doc":"Verifies that a JWT is valid: the signature is correct, and the audience is the AWS client_id","ref":"Ueberauth.Strategy.Cognito.JwtVerifier.html#verify/3","title":"Ueberauth.Strategy.Cognito.JwtVerifier.verify/3","type":"function"},{"doc":"All notable changes to this project will be documented in this file. The format is based on Keep a Changelog , and this project adheres to Semantic Versioning .","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"","ref":"changelog.html#unreleased","title":"Changelog - Unreleased","type":"extras"},{"doc":"BREAKING: remove option to handle refresh tokens by passing as an argument to the callback URL. This approach involved transmitting the refresh token to the browser and as such was in violation of the OAuth 2.0 RFC .","ref":"changelog.html#v0-4-0-2022-03-08","title":"Changelog - v0.4.0 (2022-03-08)","type":"extras"},{"doc":"Add support for configuring scopes to include.","ref":"changelog.html#v0-3-1-2022-01-14","title":"Changelog - v0.3.1 (2022-01-14)","type":"extras"},{"doc":"BREAKING: minimum ueberauth version is now 0.7 Standardize handling of CSRF Attack protection","ref":"changelog.html#v0-3-0-2021-09-01","title":"Changelog - v0.3.0 (2021-09-01)","type":"extras"},{"doc":"BREAKING: minimum Elixir version is now 1.7 Added per app configuration based on the otp_app Support some optional parameters for Cognito /authorize Modified to return info/1 with the information of User in Ueberauth.Auth.Info Thank you to @mdillavou and @yagince for their contributions to this release!","ref":"changelog.html#v0-2-0-2020-05-28","title":"Changelog - v0.2.0 (2020-05-28)","type":"extras"},{"doc":"Initial release","ref":"changelog.html#v0-1-0-2019-12-19","title":"Changelog - v0.1.0 (2019-12-19)","type":"extras"},{"doc":"Copyright (c) 2019 Massachusetts Bay Transportation Authority Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"License","type":"extras"},{"doc":"An Ueberauth Strategy for AWS Cognito.","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"Add :ueberauth and :ueberauth_cognito to your mix.exs : defp deps do [ # ... { :ueberauth , &quot;~&gt; 0.7&quot; } , { :ueberauth_cognito , &quot;~&gt; 0.3&quot; } ] end Configure Ueberauth to use this strategy: config :ueberauth , Ueberauth , providers : [ cognito : { Ueberauth.Strategy.Cognito , [ ] } ] and configure the required values: config :ueberauth , Ueberauth.Strategy.Cognito , auth_domain : { System , :get_env , [ &quot;COGNITO_DOMAIN&quot; ] } , client_id : { System , :get_env , [ &quot;COGNITO_CLIENT_ID&quot; ] } , client_secret : { System , :get_env , [ &quot;COGNITO_CLIENT_SECRET&quot; ] } , user_pool_id : { System , :get_env , [ &quot;COGNITO_USER_POOL_ID&quot; ] } , aws_region : { System , :get_env , [ &quot;COGNITO_AWS_REGION&quot; ] } # e.g. &quot;us-east-1&quot; The values can be configured with an MFA, or simply a string. Add the routes to the router: scope &quot;/auth&quot; , SignsUiWeb do pipe_through ( [ :redirect_prod_http , :browser ] ) get ( &quot;/:provider&quot; , AuthController , :request ) get ( &quot;/:provider/callback&quot; , AuthController , :callback ) end and create the corresponding controller: defmodule SignsUiWeb.AuthController do use SignsUiWeb , :controller plug ( Ueberauth ) def callback ( %{ assigns : %{ ueberauth_failure : _fails } } = conn , _params ) do # what to do if sign in fails end def callback ( %{ assigns : %{ ueberauth_auth : auth } } = conn , _params ) do # sign the user in or something. # auth is a `%Ueberauth.Auth{}` struct, with Cognito token info send_resp ( conn , 200 , &quot;Welcome, \#{ auth . uid } &quot; ) end end Note that the entry in the router defines the authentication callback URL, and will need to be whitelisted in the AWS Cognito User Pools settings.","ref":"readme.html#installation","title":"Overview - Installation","type":"extras"},{"doc":"If you wish to use Ueberauth in multiple OTP apps, and configure each instance of Ueberauth with a different list of Providers and settings, you will need to do some things differently. When providing configuration for Ueberauth, you should set anything that differs by OTP app under the name of your OTP app, for example: config :my_app, Ueberauth, providers: [ cognito: {Ueberauth.Strategy.Cognito, []} ] and configure the required values for the provider (make sure to use the same otp_app name) config :my_app , Ueberauth.Strategy.Cognito , auth_domain : { System , :get_env , [ &quot;COGNITO_DOMAIN&quot; ] } , client_id : { System , :get_env , [ &quot;COGNITO_CLIENT_ID&quot; ] } , client_secret : { System , :get_env , [ &quot;COGNITO_CLIENT_SECRET&quot; ] } , user_pool_id : { System , :get_env , [ &quot;COGNITO_USER_POOL_ID&quot; ] } , aws_region : { System , :get_env , [ &quot;COGNITO_AWS_REGION&quot; ] } # e.g. &quot;us-east-1&quot; In your controller, when using the Ueberauth plug, you should pass the :otp_app option, for example: defmodule SignsUiWeb.AuthController do use SignsUiWeb , :controller plug ( Ueberauth , otp_app : :my_app ) ...","ref":"readme.html#configuration-of-settings-per-otp-app","title":"Overview - Configuration of settings per OTP app","type":"extras"},{"doc":"Copyright (c) 2019 Massachusetts Bay Transportation Authority Source code licensed under MIT License .","ref":"readme.html#copyright-and-license","title":"Overview - Copyright and License","type":"extras"}]